- name: Resolves current version
  set_fact:
    current_tx_version: "{{ (tx_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[1]
                                if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                    and tx_dc.resources[0].spec.template is defined
                                    and tx_dc.resources[0].spec.template.spec is defined
                                    and tx_dc.resources[0].spec.template.spec.containers is defined
                                    and tx_dc.resources[0].spec.template.spec.containers[0] is defined
                                    and tx_dc.resources[0].spec.template.spec.containers[0].image is defined
                                    and (tx_dc.resources[0].spec.template.spec.containers[0].image.split(':')) | length == 2)
                                else ((tx_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[2]
                                    if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                        and tx_dc.resources[0].spec.template is defined
                                        and tx_dc.resources[0].spec.template.spec is defined
                                        and tx_dc.resources[0].spec.template.spec.containers is defined
                                        and tx_dc.resources[0].spec.template.spec.containers[0] is defined
                                        and tx_dc.resources[0].spec.template.spec.containers[0].image is defined)
                                    else (tx_dc.resources[0].spec.triggers[0].imageChangeParams.from.name.split(':'))[1]) }}"
- block:
  - name: Fails if current version unknown
    fail:
      msg: "Transmission tag unknown {{ current_tx_version }}"
    when:
    - current_tx_version not in [ '2.94.2-20210912', '2.94.2-20210918' ]
  - name: Checks upgrade supported
    fail:
      msg: "Can not upgrade from {{ current_tx_version }} to {{ transmission_tag }}"
    when:
    - >
        (current_tx_version == '2.94.2-20210918' and transmission_tag in [ '2.94.2-20210912' ])
  when:
  - current_tx_version != 'master'
  - current_tx_version != 'devel'
  - current_tx_version != 'stage'
- name: Issue a warning when migrating from master to release
  debug:
    msg: |
      WARNING - about to deploy {{ transmission_tag }} over CI version {{ current_tx_version }}
  when:
  - current_tx_version in [ 'master', 'devel', 'stage' ]
